<template>
  <div class="register">
    <div class="container-half1">
      <CarouselComponent 
        :imagenes="['https://i.ibb.co/bFJFbGV/Registro1.png']" />
    </div>
    <div class="container-half2">
      <div class="register-container">
        <h2 class="mb-4">Registro</h2>
        <br><br>
        <form @submit.prevent="submitForm">

          <div class="form-group mb-3">
            <input type="text" class="form-control" id="nombreForm" placeholder="Nombre" v-model="nombreForm" required pattern="^[A-Za-z]{1,30}$">
            <div class="invalid-feedback">El nombre no puede contener números y debe tener un máximo de 30 caracteres</div>
          </div>

          <div class="form-group mb-3">
            <input type="text" class="form-control" id="apellidoForm" placeholder="Apellido" v-model="apellidoForm" required pattern="^[A-Za-z]{1,30}$">
            <div class="invalid-feedback">El apellido no puede contener números y debe tener un máximo de 30 caracteres</div>
          </div>

          <div class="form-group mb-3">
            <input type="text" class="form-control" id="usuario" placeholder="Nombre de usuario" v-model="usuarioForm" required>
          </div>

          <div class="form-group mb-3">
            <input type="email" class="form-control" id="email" placeholder="Correo" v-model="email" required>
          </div>

          <div class="form-group mb-3">
            <input type="password" class="form-control" id="password" placeholder="Contraseña" v-model="password" required>
            <div class="invalid-feedback">La contraseña debe tener por lo menos 8 caracteres</div>
          </div>

          <div class="form-group mb-3">
            <input type="password" class="form-control" id="passwordver" placeholder="Repite tu contraseña" v-model="passwordver" required>
          <div class="error-message" v-if="password !== passwordver">Las contraseñas no coinciden</div>
          </div>

          <div class="form-group mb-3">
            <input type="date" class="form-control" id="dateForm" v-model="dateForm" required :max="today" min="1900-01-01">
            <div class="invalid-feedback">La fecha no puede ser mayor al día de hoy</div>
          </div>
          <br><br>
          <button type="submit" class="btn btn-primary btn-block mb-3">Registrarse</button>
          <router-link to="/login"><button class="btn btn-secondary btn-block">Iniciar sesion</button></router-link>
        </form>   
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios';
import CarouselComponent from '../../components/cuenta/CarouselComponent.vue';

export default {
  name: 'RegisterPage',
  components: {
    CarouselComponent,
  },
  data() {
    return {
      nombreForm: '',
      apellidoForm: '',
      usuarioForm: '',
      email: '',
      password: '',
      passwordver: '',
      dateForm: '',
      today: new Date().toISOString().slice(0,10),
      errorMessage: '',
    };
  },
  watch: {
    nombreForm(newValue) {
      this.nombreForm = newValue.charAt(0).toUpperCase() + newValue.slice(1).toLowerCase();
    },
    apellidoForm(newValue) {
      this.apellidoForm = newValue.charAt(0).toUpperCase() + newValue.slice(1).toLowerCase();
    },
  },
  methods: {
    submitForm() {
      if (!this.validations()) return;
      this.errorMessage = "";
      const usuario = {
        email: this.email,
        nombreUsuario: this.usuarioForm,
        nombre: this.nombreForm,
        apellido: this.apellidoForm,
        clave: this.password,
        fechaNacimiento: this.dateForm,
      };
      console.log(usuario);
      axios.post('http://localhost:3001/usuarios/registro', usuario)
        .then(response => {
          console.log(response.data);
          alert('Se ha enviado correo al email asociado para verificar la cuenta')
          this.$router.push('/login');
        })
        .catch(error => {
          console.error(error);
        });
    },
    validations() {
      if (!this.nombreForm || !this.apellidoForm || !this.usuarioForm || !this.email || !this.password || !this.passwordver || !this.dateForm) {
        this.errorMessage = "Por favor, complete todos los campos requeridos.";
        alert(this.errorMessage);
        return false;
      }
      if (this.password !== this.passwordver) {
        this.errorMessage = "Las contraseñas no coinciden.";
        alert(this.errorMessage);
        return false;
      }
      if (this.dateForm > this.today || this.dateForm < '1900-01-01') {
        this.errorMessage = "La fecha no puede ser mayor al día de hoy";
        alert(this.errorMessage);
        return false;
      }
      if (this.password.length <8) {
        this.errorMessage = "La contraseña debe tener por lo menos 8 caracteres.";
        alert(this.errorMessage);
        return false;
      }
      // Agregar aquí más validaciones según sea necesario
      return true;
    }
  },
};
</script>

<style scoped>
.register {
  display: flex;
  flex-direction: row;
  justify-content: center;
  align-items: center;
  height: 100vh;
  background-color: #ffffff;
}

.container-half2 {
  width: 50%;
}

.container-half1 {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  width: 50%;
  background-color: #4d6dcf;
}

.register-container {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  padding: 20px;
}

.register-container .form-group {
  width: 100%;
  margin-bottom: 30px;
}

.register-container .form-group .error-message {
  min-height: 20px; 
  color: red;
}

.register-container button {
  width: 100%;
}

.register-container button.btn-primary {
  color: #fff;
}
</style>
